"use strict";

var _regenerator = require("babel-runtime/regenerator");

var _regenerator2 = _interopRequireDefault(_regenerator);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _enzyme = require("enzyme");

var _redux = require("redux");

var _reactRedux = require("react-redux");

var _effects = require("redux-saga/effects");

var _ = require("./");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _global = global,
    describe = _global.describe,
    beforeAll = _global.beforeAll,
    it = _global.it,
    expect = _global.expect;


var getWrappedSagaComponent = function getWrappedSagaComponent(prefix) {
  var _marked = /*#__PURE__*/_regenerator2.default.mark(nameSetSaga),
      _marked2 = /*#__PURE__*/_regenerator2.default.mark(saga);

  var isSetting = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

  // constants
  var NAME_SEND = prefix + "/NAME_SEND";
  var NAME_SET = prefix + "/NAME_SET";

  // actions
  var nameSendAction = function nameSendAction(name) {
    return {
      type: NAME_SEND,
      payload: name
    };
  };

  var nameSetAction = function nameSetAction(name) {
    return {
      type: NAME_SET,
      payload: name
    };
  };

  // reducers
  var reducer = function reducer() {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "no-name";
    var _ref = arguments[1];
    var type = _ref.type,
        payload = _ref.payload;

    switch (type) {
      case NAME_SET:
        return payload;
      default:
        return state;
    }
  };

  // sagas
  function nameSetSaga(action) {
    var name;
    return _regenerator2.default.wrap(function nameSetSaga$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            name = action.payload;
            _context.next = 3;
            return (0, _effects.put)(nameSetAction(name));

          case 3:
          case "end":
            return _context.stop();
        }
      }
    }, _marked, this);
  }

  function saga() {
    return _regenerator2.default.wrap(function saga$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return (0, _effects.takeLatest)(NAME_SEND, nameSetSaga);

          case 2:
          case "end":
            return _context2.stop();
        }
      }
    }, _marked2, this);
  }

  var withReducer = (0, _.injectReducer)({ key: prefix + "/testReducer", reducer: reducer });
  var withSaga = (0, _.injectSaga)({ key: prefix + "/testSaga", saga: saga });
  var withConnect = (0, _reactRedux.connect)(function (state) {
    return { name: state.get(prefix + "/testReducer") };
  }, // mapStateToProps
  function (dispatch) {
    return (0, _redux.bindActionCreators)({ nameSend: nameSendAction }, dispatch);
  } // mapDispatchToProps
  );

  var Component = function (_React$Component) {
    _inherits(Component, _React$Component);

    function Component() {
      _classCallCheck(this, Component);

      return _possibleConstructorReturn(this, (Component.__proto__ || Object.getPrototypeOf(Component)).apply(this, arguments));
    }

    _createClass(Component, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        if (isSetting) {
          this.props.nameSend("Name " + prefix);
        }
      }
    }, {
      key: "render",
      value: function render() {
        return _react2.default.createElement(
          "span",
          null,
          this.props.name
        );
      }
    }]);

    return Component;
  }(_react2.default.Component);

  // prettier-ignore


  return (0, _redux.compose)(withReducer, withSaga, withConnect)(Component);
};

var getWrappedThunkComponent = function getWrappedThunkComponent(prefix) {
  // constants
  var NAME_SET = prefix + "/NAME_SET";

  var nameSetAction = function nameSetAction(name) {
    return {
      type: NAME_SET,
      payload: name
    };
  };

  // reducers
  var reducer = function reducer() {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "no-name";
    var _ref2 = arguments[1];
    var type = _ref2.type,
        payload = _ref2.payload;

    switch (type) {
      case NAME_SET:
        return payload;
      default:
        return state;
    }
  };

  // thunks
  var nameSendThunk = function nameSendThunk(name) {
    return function (dispatch) {
      return dispatch(nameSetAction(name));
    };
  };

  var withReducer = (0, _.injectReducer)({ key: prefix + "/testReducer", reducer: reducer });
  var withConnect = (0, _reactRedux.connect)(function (state) {
    return { name: state.get(prefix + "/testReducer") };
  }, // mapStateToProps
  function (dispatch) {
    return (0, _redux.bindActionCreators)({ nameSend: nameSendThunk }, dispatch);
  } // mapDispatchToProps
  );

  var Component = function (_React$Component2) {
    _inherits(Component, _React$Component2);

    function Component() {
      _classCallCheck(this, Component);

      return _possibleConstructorReturn(this, (Component.__proto__ || Object.getPrototypeOf(Component)).apply(this, arguments));
    }

    _createClass(Component, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        this.props.nameSend("Name " + prefix);
      }
    }, {
      key: "render",
      value: function render() {
        return _react2.default.createElement(
          "span",
          null,
          this.props.name
        );
      }
    }]);

    return Component;
  }(_react2.default.Component);

  // prettier-ignore


  return (0, _redux.compose)(withReducer, withConnect)(Component);
};

describe("configureStore", function () {
  it("default store, without parameters", function () {
    var store = (0, _.configureStore)();
    expect(store.getState()).toMatchSnapshot();
  });

  it("store with reducers parameter", function () {
    function staticReducer() {
      var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

      return state;
    }

    var reducers = { config: staticReducer };
    var store = (0, _.configureStore)(reducers);
    expect(store.getState()).toMatchSnapshot();
  });

  it("store with reducers and initialState parameter", function () {
    function staticReducer() {
      var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

      return state;
    }

    var reducers = { config: staticReducer };
    var initialState = { config: true };
    var store = (0, _.configureStore)(reducers, initialState);
    expect(store.getState()).toMatchSnapshot();
  });
});

describe("configureStore and inject reducers, sagas and thunks", function () {
  var store = void 0;

  beforeAll(function () {
    store = (0, _.configureStore)();
  });

  it("default store", function () {
    expect(store.getState()).toMatchSnapshot();
  });

  it("component A, with reducer and saga", function () {
    var WrappedComponent = getWrappedSagaComponent("A");

    expect(store.getState()).toMatchSnapshot();
    var component = (0, _enzyme.mount)(_react2.default.createElement(WrappedComponent, null), { context: { store: store } });
    expect(component).toMatchSnapshot();
    expect(store.getState()).toMatchSnapshot();
  });

  it("component B, with reducer and saga", function () {
    var WrappedComponent = getWrappedSagaComponent("B");

    expect(store.getState()).toMatchSnapshot();
    var component = (0, _enzyme.mount)(_react2.default.createElement(WrappedComponent, null), { context: { store: store } });
    expect(component).toMatchSnapshot();
    expect(store.getState()).toMatchSnapshot();
  });

  it("component C, with reducer and using thunk", function () {
    var WrappedComponent = getWrappedThunkComponent("C");

    expect(store.getState()).toMatchSnapshot();
    var component = (0, _enzyme.mount)(_react2.default.createElement(WrappedComponent, null), { context: { store: store } });
    expect(component).toMatchSnapshot();
    expect(store.getState()).toMatchSnapshot();
  });

  it("component A2, with reducer and saga should not override current state", function () {
    var WrappedComponent = getWrappedSagaComponent("A", false);

    expect(store.getState()).toMatchSnapshot();
    var component = (0, _enzyme.mount)(_react2.default.createElement(WrappedComponent, null), { context: { store: store } });
    expect(component).toMatchSnapshot();
    expect(store.getState()).toMatchSnapshot();
  });
});