"use strict";

var _checkStore = require("./checkStore");

var _checkStore2 = _interopRequireDefault(_checkStore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe("checkStore", function () {
  var store = void 0;

  beforeEach(function () {
    store = {
      dispatch: function dispatch() {},
      subscribe: function subscribe() {},
      getState: function getState() {},
      replaceReducer: function replaceReducer() {},
      runSaga: function runSaga() {},
      injectedReducers: {},
      injectedSagas: {}
    };
  });

  it("should not throw if passed valid store shape", function () {
    expect(function () {
      return (0, _checkStore2.default)(store);
    }).not.toThrow();
  });

  it("should throw if passed invalid store shape", function () {
    expect(function () {
      return (0, _checkStore2.default)({});
    }).toThrow();
    expect(function () {
      return (0, _checkStore2.default)(Object.assign({}, store, { injectedSagas: null }));
    }).toThrow();
    expect(function () {
      return (0, _checkStore2.default)(Object.assign({}, store, { injectedReducers: null }));
    }).toThrow();
    expect(function () {
      return (0, _checkStore2.default)(Object.assign({}, store, { runSaga: null }));
    }).toThrow();
    expect(function () {
      return (0, _checkStore2.default)(Object.assign({}, store, { replaceReducer: null }));
    }).toThrow();
  });
}); /**
     * Test injectors
     */