"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _hoistNonReactStatics = require("hoist-non-react-statics");

var _hoistNonReactStatics2 = _interopRequireDefault(_hoistNonReactStatics);

var _reducerInjectors = require("./reducerInjectors");

var _reducerInjectors2 = _interopRequireDefault(_reducerInjectors);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Dynamically injects a reducer
 *
 * @param {string} key A key of the reducer
 * @param {function} reducer A reducer that will be injected
 *
 */
exports.default = function (_ref) {
  var key = _ref.key,
      reducer = _ref.reducer;
  return function (WrappedComponent) {
    var ReducerInjector = function (_React$Component) {
      _inherits(ReducerInjector, _React$Component);

      function ReducerInjector() {
        var _ref2;

        var _temp, _this, _ret;

        _classCallCheck(this, ReducerInjector);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref2 = ReducerInjector.__proto__ || Object.getPrototypeOf(ReducerInjector)).call.apply(_ref2, [this].concat(args))), _this), _this.injectors = (0, _reducerInjectors2.default)(_this.context.store), _temp), _possibleConstructorReturn(_this, _ret);
      }

      _createClass(ReducerInjector, [{
        key: "UNSAFE_componentWillMount",


        // eslint-disable-next-line camelcase
        value: function UNSAFE_componentWillMount() {
          var injectReducer = this.injectors.injectReducer;


          injectReducer(key, reducer);
        }
      }, {
        key: "render",
        value: function render() {
          return _react2.default.createElement(WrappedComponent, this.props);
        }
      }]);

      return ReducerInjector;
    }(_react2.default.Component);

    ReducerInjector.WrappedComponent = WrappedComponent;
    ReducerInjector.contextTypes = {
      store: _propTypes2.default.object.isRequired
    };
    ReducerInjector.displayName = "withReducer(" + (WrappedComponent.displayName || WrappedComponent.name || "Component") + ")";


    return (0, _hoistNonReactStatics2.default)(ReducerInjector, WrappedComponent);
  };
};