"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = routeReducer;

var _immutable = require("immutable");

var _reactRouterRedux = require("react-router-redux");

/*
 * routeReducer
 *
 * The reducer merges route location changes into our immutable state.
 * The change is necessitated by moving to react-router-redux@4
 *
 */

// Initial routing state
var routeInitialState = (0, _immutable.fromJS)({
  location: null
});

/**
 * Merge route into the global application state
 */
function routeReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : routeInitialState;
  var action = arguments[1];

  switch (action.type) {
    /* istanbul ignore next */
    case _reactRouterRedux.LOCATION_CHANGE:
      return state.merge({
        location: action.payload
      });
    default:
      return state;
  }
}